"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Transient = exports.Singleton = void 0;
var Singleton = /** @class */ (function () {
    function Singleton(container, className, providerName, factoryFunction) {
        this.container = container;
        this.className = className;
        this.providerName = providerName;
        this.factoryFunction = factoryFunction;
    }
    Singleton.prototype.provide = function () {
        return this.value || (this.value = this.factoryFunction(this.container.build()));
    };
    return Singleton;
}());
exports.Singleton = Singleton;
var Transient = /** @class */ (function () {
    function Transient(container, className, providerName, factoryFunction) {
        this.container = container;
        this.className = className;
        this.providerName = providerName;
        this.factory = factoryFunction;
    }
    Transient.prototype.provide = function () {
        return this.factory(this.container.build());
    };
    return Transient;
}());
exports.Transient = Transient;
